//
//	ADCategory.m
//	  Written by Carl Lindberg Copyright 1998 by Carl Lindberg.
//                     All rights reserved.
//		This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


#import "ADCategory.h"
#import "ADComment.h"
#import "ADUtilities.h"

#import <Foundation/NSString.h>

@implementation ADCategory 

+ category
{
	return [[[self alloc] init] autorelease];
}

- init
{
	[super init];
	[self setDescriptionString:@"No category description."];
	return self;
}

- (void)dealloc
{
	[className release];
	[categoryName release];
	[super dealloc];
}

- (NSString *)className		{	return className;		}
- (NSString *)categoryName	{	return categoryName;	}

- (void)setClassName:(NSString *)aName		{	SETIVAR(className, aName);		}
- (void)setCategoryName:(NSString *)aName	{	SETIVAR(categoryName, aName);	}

- (NSString *)title
{
	return [NSString stringWithFormat:@"%@ (%@)", [self className], [self categoryName]];
}

- (NSString *)interfaceTitle
{
	return @"Category";
}

- (NSString *)uniqueFileBasename
{
	return [NSString stringWithFormat:@"%@+%@", [self className], [self categoryName]];
}

- (NSString *)typeDirectoryName
{
//  return @"Categories";
    return @"Classes";
}

- description
{
	return [NSString stringWithFormat:@"@interface %@ (%@) %@\n%@%@",
				className,
				categoryName,
				[self conformedProtocolString],
				[self entityDescription],
				[self declarationArray]];
}

@end
