//
//    ADInlineFunction.m 
//      Written by Carl Lindberg Copyright 1999 by Carl Lindberg.
//                       All rights reserved.
//        This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	
//  This file formatted with 4 spaces per tabstop.

#import "ADInlineFunction.h"
#import <MiscFoundation.subproj/NSString+MiscAdditions.h>

@implementation ADInlineFunction
/*" Represents a "static inline" C function. "*/

- initWithString:(NSString *)string
{
    NSString *firstWord = [string wordNum:0];

    /*
     * ADFunction's super implementation strips out the first word.  If we
     * were declared "static inline", we need to strip out another leading
     * word as well.
     */
    if ([firstWord isEqual:@"static"])
    {
        return [super initWithString:[string substringFromEndOfString:firstWord]];
    }

    return [super initWithString:string];
}

- description
{
    return [NSString stringWithFormat:@"static inline %@%@(%@)", type, name, parameterString];
}

@end
