//
//	ADInterface.h
//	  Written by Carl Lindberg Copyright 1998 by Carl Lindberg.
//                     All rights reserved.
//		This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "ADEntity.h"

@class NSArray, NSMutableArray, NSMutableDictionary;
@class ADMethod;

@interface ADInterface : ADEntity
{
	NSArray	*conformedProtocolArray;
	NSMutableArray *declarationArray;
	NSMutableDictionary *methodDictionary;
}

/*" Getting the title "*/
- (NSString *)title;
- (NSString *)interfaceTitle;
- (NSString *)uniqueFileBasename;
- (NSString *)typeDirectoryName;

/*" Protocols the interface conforms to "*/
- (NSArray *)conformedProtocols;
- (void)setConformedProtocols:(NSArray *)protocolNameArray;
- (NSString *)conformedProtocolString;

/*" Retrieving declared methods "*/
- (NSArray *)declarationArray;
- (ADMethod *)methodNamed:(NSString *)methodName;
- (NSArray *)classMethods;
- (NSArray *)instanceMethods;

/*" Parser support "*/
- (void)addDeclarationsFromArray:(NSArray *)array;
- (void)addDeclaration:(id)anObject;
- (void)setMethodDescriptionsFromArray:(NSArray *)methodArray;

@end
