//
//	ADIvar.h
//	  Written by Carl Lindberg Copyright 1998 by Carl Lindberg.
//                     All rights reserved.
//		This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "ADEntity.h"

@class NSArray;
@class ADCompoundIvar;

@interface ADIvar : ADEntity
{
	NSString		*name;
	NSString		*type;
	NSString		*posttype;
	ADCompoundIvar	*parentIvar;
}

/*" Creating ADIvars "*/
+ ivarWithString:(NSString *)string;
+ ivarWithName:(NSString *)aName;
- initWithString:(NSString *)string;
- initWithName:(NSString *)aName;

/*" Querying attributes "*/
- (NSString *)name;
- (NSString *)type;
- (NSString *)posttype;
- (NSString *)fullName;
- (ADCompoundIvar *)parentIvar;
- (void)setParentIvar:(ADCompoundIvar *)anIvar;
- (void)setType:(NSString *)aType;

@end
