//
//	ADMethod.h
//	  Written by Carl Lindberg Copyright 1998 by Carl Lindberg.
//                     All rights reserved.
//		This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "ADEntity.h"

@class NSArray, NSMutableArray;

@interface ADMethod : ADEntity
{
	BOOL isClassMethod;
	BOOL isVarargMethod;
	NSString *returnType;
	NSMutableArray *argumentNames;
	NSMutableArray *argumentTypes;
	NSMutableArray *variableNames;
}

/*" Creating a new ADMethod "*/
+ method;

/*" Accessing and setting attributes "*/
- (BOOL)isClassMethod;
- (BOOL)isVarargMethod;
- (void)setClassMethod:(BOOL)yorn;
- (void)setIsVarargMethod:(BOOL)yorn;

- (NSString *)returnType;
- (void)setReturnType:(NSString *)type;

- (NSArray *)argumentNames;
- (NSArray *)argumentTypes;
- (NSArray *)variableNames;
- (unsigned)argumentCount;
- (NSArray *)arguments;

/*" Getting string descriptions "*/
- (NSString *)selectorName;
- (NSString *)methodName;
- (NSString *)fullMethodName;
- (NSString *)description;

/*" Comparing ADMethods "*/
- (NSComparisonResult)compareMethod:(ADMethod *)otherMethod;

/*" Parser support "*/
- (void)addArgument:(NSString *)argName type:(NSString *)argType varName:(NSString *)varName;
- (void)setFirstArgumentName:(NSString *)aName;

@end
