//
//	ADOutputModule.h
//	  Written by Carl Lindberg Copyright 1998 by Carl Lindberg.
//                     All rights reserved.
//		This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <Foundation/NSObject.h>

@class NSArray;
@class ADFile;

@interface ADOutputModule : NSObject

+ (ADOutputModule *)currentModule;
+ (void)setCurrentModuleFromString:(NSString *)aString;

- (NSString *)fileExtension;
- (NSString *)templateFilename;
- (NSArray *)documentationExtensions;

- (NSString *)startBold;
- (NSString *)stopBold;
- (NSString *)startItalics;
- (NSString *)stopItalics;

- (NSString *)paragraphSeparator;
- (NSString *)lineSeparator;

- (NSString *)listPrefixString;
- (NSString *)listPostfixString;
- (NSString *)listItemReplaceString;
- (NSString *)listParagraphSeparator;

- (NSString *)postProcessString:(NSString *)string;
- (NSString *)preProcessString:(NSString *)string;

- (NSString *)valueIndentString;

- (void)outputContents:(ADFile *)fileContents toFile:(NSString *)outputFilename;

@end
