//
//  ADInputHandler.h 
//    Written by Carl Lindberg Copyright 1999 by Carl Lindberg.
//                     All rights reserved.
//      This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	
//  This file formatted with 4 spaces per tabstop.

#import <Foundation/NSObject.h>

@class ADFile;

@interface ADInputHandler : NSObject
{
}

/*" Handling input files "*/
+ (void)handleInputFile:(NSString *)filename;

/*" Support methods "*/
+ (NSString *)outputFilenameForInputFilename:(NSString *)inputFilename;
+ (NSString *)outputFilenameForADFile:(ADFile *)adFile;
+ (BOOL)shouldOutputToFile:(NSString *)targetFilename fromFile:(NSString *)sourceFilename;
+ (BOOL)shouldOutputToFile:(NSString *)targetFilename fromADFile:(ADFile *)adFile;
+ (void)createPathForOutputFile:(NSString *)filename;
+ (void)outputADFile:(ADFile *)adFile;
+ (void)handleMainADFile:(ADFile *)adFile;

@end
