# $Id: autodoc.make,v 1.3 1999/09/03 20:25:51 aswift Exp $
#
# autodoc.make
#
# Rules for installing public documentation.
#
# PUBLIC TARGETS
#
# IMPORTED VARIABLES
#     OTHER_PUBLIC_DOCUMENTATION:  documentation (.rtf or .html) files which 
#     should be installed/copied into the public documentation location
#     PUBLIC_DOC_INSTALLDIR:  the directory into which public documentation 
#     should be installed
#

.PHONY: install-public-headers announce-documentation installdocs-directories

# autodoc execution stuff
AUTODOC = /usr/local/bin/autodoc
AUTODOC_FLAGS = -copydocs -comment standardc -comment doubleslash -timestamp -allclasses

announce-documentation:
ifndef RECURSING
	$(SILENT) $(ECHO) Installing documentation...
else
	$(SILENT) $(ECHO) $(RECURSIVE_ELLIPSIS)installing documentation from $(NAME)
endif


#
# Ensure that important directories exist
#

installdocs-directories: $(SFILE_DIR)

#
# If there are any public headers we must copy them to the destination directory
#

ifneq "" "$(PUBLIC_HEADERS)$(OTHER_PUBLIC_HEADERS)"
install-public-documentation: installdocs-directories announce-documentation $(DSTROOT)$(PUBLIC_DOC_INSTALLDIR) $(PUBLIC_HEADERS) $(OTHER_PUBLIC_HEADERS) $(OTHER_PUBLIC_DOCUMENTATION)
ifneq "$(PUBLIC_DOC_INSTALLDIR)" ""
	$(SILENT) $(AUTODOC) $(AUTODOC_FLAGS) $(OTHER_AUTODOC_FLAGS) -dest $(DSTROOT)$(PUBLIC_DOC_INSTALLDIR) $(PUBLIC_HEADERS) $(OTHER_PUBLIC_HEADERS) $(OTHER_PUBLIC_DOCUMENTATION)
else
	$(SILENT) $(ECHO) Must set a public documentation directory to install public documentation. ;  exit 1
endif
endif

$(DSTROOT)$(PUBLIC_DOC_INSTALLDIR):
	$(MKDIRS) $@

