/* AppDelegate.m created by clindber on Fri 23-Jul-1999 */

#import "FormatComment.h"
#import <Foundation/NSTask.h>
#import <Foundation/NSFileHandle.h>
#import <Foundation/NSData.h>
#import <Foundation/NSString.h>
#import <Foundation/NSBundle.h>
#import <AppKit/NSPasteboard.h>
#import <AppKit/NSWorkspace.h>

@implementation FormatComment

- (NSString *)formatComment:(NSString *)comment error:(NSString **)error
{
    NSPipe *output = [[NSPipe alloc] init];
    NSPipe *input = [[NSPipe alloc] init];
    NSTask *task = [[NSTask alloc] init];
    NSString *formatCommentPath = [[NSBundle mainBundle] pathForResource:@"format_comment" ofType:@"pl"];
    NSString *perlPath;
    NSData *outputData;
    NSString *outputString;

    perlPath = 	[[NSWorkspace sharedWorkspace] fullPathForApplication:@"perl"];

    if (![[NSFileManager defaultManager] fileExistsAtPath:perlPath])
    {
#ifdef WIN32
        perlPath = @"C:\\Perl\\bin\\perl.exe";
#else
        perlPath = @"/usr/bin/perl";
#endif
    }

    if (![[NSFileManager defaultManager] fileExistsAtPath:perlPath])
    {
        *error = @"Could not find Perl executable.";
        return comment;
    }
    
    [task setLaunchPath:perlPath];
    [task setArguments:[NSArray arrayWithObject:formatCommentPath]];
    [task setStandardInput:input];
    [task setStandardOutput:output];
    [task launch];

    [[input fileHandleForWriting] writeData:[comment dataUsingEncoding:[NSString defaultCStringEncoding]]];
    [[input fileHandleForWriting] closeFile];

    outputData = [[output fileHandleForReading] readDataToEndOfFile];
    outputString = [[NSString alloc] initWithData:outputData encoding:[NSString defaultCStringEncoding]];

    [task waitUntilExit];
    [input release];
    [output release];
    [task release];

    return [outputString autorelease];
}

- (void)formatComment:(NSPasteboard *)pboard userData:(NSString *)data error:(NSString **)error    
{
    NSString *comment;
    NSArray *types = [pboard types];

    if ([types containsObject:NSStringPboardType])
    {
        comment = [pboard stringForType:NSStringPboardType];

        [pboard declareTypes:[NSArray arrayWithObject:NSStringPboardType] owner:nil];
        [pboard setString:[self formatComment:comment error:error] forType:NSStringPboardType];
    }
    else
    {
        *error = @"No string!";
    }
}

@end

